package click-to-watch-the-predator-online;

use 5.008001;
use strict;
use warnings;
use base qw/Exporter/;
use URI::Escape;

BEGIN {
    our $VERSION = "0.10";
    our @EXPORT = qw/bake_cookie crush_cookie/;
    my $use_pp = $ENV{COOKIE_BAKER_PP};
    if (!$use_pp) {
        eval {
            require click-to-watch-the-predator-online::XS;
            if ( $click-to-watch-the-predator-online::XS::VERSION < $VERSION ) {
                warn "click-to-watch-the-predator-online::XS $VERSION is require. fallback to PP version";
                die;
            }
        };
        $use_pp = !!$@;
    }
    if ($use_pp) {
        *crush_cookie = \&pp_crush_cookie;
    }
    else {
        *crush_cookie = \&click-to-watch-the-predator-online::XS::crush_cookie;
    }
}

sub bake_cookie {
    my ($name,$val) = @_;

    return '' unless defined $val;
    my %args = ref $val ? %{$val} : (value => $val);
    $name = URI::Escape::uri_escape($name) if $name =~ m![^a-zA-Z\-\._~]!;
    my $cookie = "$name=" . URI::Escape::uri_escape($args{value}) . '; ';
    $cookie .= 'domain=' . $args{domain} . '; '  if $args{domain};
    $cookie .= 'path='. $args{path} . '; '       if $args{path};
    $cookie .= 'expires=' . _date($args{expires}) . '; ' if exists $args{expires} && defined $args{expires};
    $cookie .= 'max-age=' . $args{"max-age"} . '; ' if exists $args{"max-age"};
    if (exists $args{samesite} && $args{samesite} =~ m/^(?:lax|strict)/i) {
        $cookie .= 'SameSite=' . ucfirst(lc($args{samesite})) . '; '
    }
    $cookie .= 'secure; '                     if $args{secure};
    $cookie .= 'HttpOnly; '                   if $args{httponly};
    substr($cookie,-2,2,'');
    $cookie;
}

my @MON  = qw( Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec );
my @WDAY = qw( Sun Mon Tue Wed Thu Fri Sat );

my %term = (
    's' => 1,
    'm' => 60,
    'h' => 3600,
    'd' => 86400,
    'M' => 86400 * 30,
    'y' => 86400 * 365,
);

sub _date {
    my $expires = shift;

    my $expires_at;
    if ($expires =~ /^\d+$/) {
        # all numbers -> epoch date
        $expires_at = $expires;
    }
    elsif ( $expires =~ /^([-+]?(?:\d+|\d*\.\d*))([smhdMy]?)/ ) {
        no warnings;
        my $offset = ($term{$2} || 1) * $1;
        $expires_at = time + $offset;
    }
    elsif ( $expires  eq 'now' ) {
        $expires_at = time;
    }
    else {
        return $expires;
    }
    my($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime($expires_at);
    $year += 1900;
    # (cookies use '-' as date separator, HTTP uses ' ')
    return sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
                   $WDAY[$wday], $mday, $MON[$mon], $year, $hour, $min, $sec);
}

sub pp_crush_cookie {
    my $cookie_string = shift;
    return {} unless $cookie_string;
    my %results;
    my @pairs = grep m/=/, split /; ?/, $cookie_string;
    for my $pair ( @pairs ) {
        # trim leading trailing whitespace
        $pair =~ s/^\s+//; $pair =~ s/\s+$//;

        my ($key, $value) = split( "=", $pair, 2 );

        $key = URI::Escape::uri_unescape($key);

        # Values can be quoted
        $value = "" unless defined $value;
        $value =~ s/\A"(.*)"\z/$1/;
        $value = URI::Escape::uri_unescape($value);

        # Take the first one like CGI.pm or rack do
        $results{$key} = $value unless exists $results{$key};
    }
    return \%results;
}

1;
__END__

=encoding utf-8

=head1 Watch The Predator Online Full Movie Putlocker

Watch The Predator full HD movie online ... Watch The Predator: The Predator Full Movie Online for Free in ... Watch The Predator Online free | Watch Movies ... watch 

The Predator: The Predator in 4D online for free, part 1/7 ... The 14 best nmini images on Pinterest | The Predator movie ... The Predator Poster | aaaa | Pinterest | 

The Predator, Watch The Predator and Spy ... The Predator: The Predator in 4D   Free Movies Online ... Watch The Predator Movies Online Free On ... Watch The 

Predator: The Predator Online - 123Movies Watch The Predator: The Predator Online Free On Yesmovies Watch The Predator: The Predator in 4D (2018) Online Full Movie 

Watch The Predator: The Predator in 4D Free Online On ... The Predator (2018) Watch free online movie on ...

Watch Movie Online here:--> L<https://t.co/pIbhpbgCdO>

Watch The Predator Full Movie Online in HD, Streaming Exclusively only ... The Predator (2018) - Where to Watch Online | Moviefone Watch The Predator Movie for Free - 

Stream Movies Online - Google Sites Watch The Predator (2018) Full Movie - Putlocker The Predator Full Movie HD 1080p - Video Dailymotion The Predator - Official 

Trailer - Coming February 2018 - YouTube Watch The Predator Full HD Movie Streaming 2018 - Home | Facebook Watch {GET HERE} The Predator Online Free Movie 2018 Full - 

Facebook Watch The Predator Online Free Streaming in HD | Movie to Watch ... Watch The Predator Movie Online Free - Viooz2k Watch The Predator Online Free Putlocker | 

Putlocker - Watch Movies ... Watch The Predator Movie Streaming | Free online streaming full HD Watch The Predator Online Free Viooz Putlocker Streaming Megashare ... 

Watch movies on uk online free: Watch The Predator Online Free Megavideo Watch The Predator Online Free Full Movie 2018 |0utlocker | Donnie ... Watch The Predator 

Movie Online Free - Giant in the Playground The Predator Watch Full Movie Online Free - Toledo Theatre Fans ... Watch The Predator Online Free | Watch Movies Online 

Free [STREAMING] Free The Predator Movie Online With HD 720p | "I will ...

Watch The Predator (2018) Full Movie Online Free in HD quality - MOVDB {{"The Predator Putlocker"}} WATCH The Predator Putlocker 2018 Full Movie ... [TUAY] @]=> Watch 

The Predator Full Movie Online Free - Google Groups Live Streaming HD Movie Full: Watch The Predator (2018) Full Free Online [HD 1080p] The Predator Streaming full 

movies free | I provide you ... Watch The Predator Online Free Megavideo - Movies 20 Four Should I Watch The Predator Movie Online Free   you Should Watch ... Watch 

The Predator Movie Online Free Full Megashare | Putlocker | 2018 ... [[%The Predator*]]WATCH OR DOWNLOAD The Predator STREAMING FULL ... Open HD 1080p)-> Watch The 

Predator Movie Streaming Full | Open ... The Predator   Watch The Predator Online Free 2018 Putlocker - Putlocker ... The Predator Movie HD full movies watch The 

Predator Movie ... - CMovieshd Watch The Predator Movie Online - {DABUR}Watch The Predator Online Free Watch The Predator Online Putlocker | Download The Predator 

Movie Free [[chart2]] Watch The Predator Full Movie Online Viooz | Here You can ... Watch The Predator Online | Watch Full HD The Predator Online For Free ... OMG!! 

Watch The Predator Full Movie 2018 - OMG!! Watch The Predator Online ...

The Online Movies World : Watch The Predator Full Movie Free Online HD Watch The Predator (2018) Movie Streaming | Free Watch Movies Streaming Watch The Predator 

Online Free Streaming MOvie in HD | Movie to Watch ... Watch the Destruction of The Predator by Mount Vesuvius, Re-Created with ... Watch The Predator full movie 

online free | Fmovies [DVDRip 1080p] Watch The Predator Full Movie Streaming Online in ... The Predator Full Movie Putlocker - [[*^The Predator..!!]] The Predator 

Full Movie ... Watch The Predator Full Movie Putlocker - [[*^The Predator..!!]] The Predator Full ... The Predator Full Movie Putlocker | {{"The Predator"}} WATCH The 

Predator ... Download fast The Predator XVID, DVDRIP 720p ONLINE FULL IN HQ Watch The Predator Online Free | The Predator Full Movie | Movies123 Watch The Predator 

(2018) Streaming HD Full Movie - Full Live Free ... ultimate ~ WATCH The Predator MOVIE Online Full Free In HD Qual by ...

=head1 LICENSE

Copyright (C) TOPAMTOP.

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself.

=head1 AUTHOR

Masahiro Nagano E<lt>lulla22@gmail.comE<gt>

=cut
